import { Logger, LoggerLevel } from "./../libs/logger";
import { Element } from "./element.interface";
import { RootScene } from './root-scene';
import { Scene } from "./scene/scene";
export declare abstract class ElementShadow implements Element {
    private $$evalExps;
    $$ignoreEvalProps: string[];
    title?: string;
    ignore?: boolean;
    ignoreError?: boolean;
    error?: any;
    log?: LoggerLevel;
    vars?: Object;
    async?: boolean;
    loop?: string;
    loopKey?: any;
    loopValue?: any;
    if?: any;
    tag: string;
    parent: ElementShadow;
    result?: any;
    logger: Logger;
    scene: Scene;
    rootScene: RootScene;
    getParentByClassName<T extends ElementShadow>(ClazzType: new (...args: any[]) => T): T;
    setVarsAfterExec(): Promise<void>;
    evalPropsBeforeExec(): Promise<void>;
    $$getLoggerLevel(): LoggerLevel;
    $$prepare(): Promise<boolean>;
    $$markElementNeedReplace(): void;
    $$extend(ids: string[] | string): {} | undefined;
    $$clone(): this;
    $$export(id: string, props: any): void;
    protected callFunctionScript(script: string, ctx?: this, others?: {
        [varName: string]: any;
    }): Promise<any>;
    init(_props?: any): void;
    abstract exec(input?: any): any;
    dispose(): void;
}
export declare function copyElementShadowPrototype(elem: any): void;
