"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const file_temp_1 = require("../../../libs/file-temp");
const testing_1 = require("../../../testing");
const sub_1 = require("./sub");
let sub;
const tmp = new file_temp_1.FileTemp();
beforeEach(() => {
    testing_1.Testing.reset();
    sub = testing_1.Testing.newElement(sub_1.Sub);
});
afterEach(async () => {
    await sub.dispose();
    tmp.remove();
});
test('Listen to handle jobs in queue', async () => {
    const jobData = { foo: 'bar' };
    await sub.init({
        address: '0.0.0.0:4001',
        queue: {
            file: tmp.file
        },
        runs: [
            {
                vars: {
                    jobData: '${this.parentJobData}'
                }
            },
            {
                "http/jobs'stop": null
            }
        ]
    });
    const t = new Promise((r, e) => {
        setTimeout(async () => {
            try {
                await fetch('http://0.0.0.0:4001', {
                    method: 'POST',
                    body: JSON.stringify(jobData)
                });
            }
            catch (err) {
                e(err);
            }
            r(undefined);
        }, 500);
    });
    await sub.exec();
    await t;
    expect(testing_1.Testing.vars.jobData).toEqual(jobData);
    expect(tmp.isExisted).toBe(true);
});
//# sourceMappingURL=sub.spec.js.map