"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const testing_1 = require("../../testing");
const number_1 = require("./number");
let input;
beforeEach(() => {
    input = testing_1.Testing.newElement(number_1.Number);
    testing_1.Testing.reset();
});
afterEach(async () => {
    await input.dispose();
});
test('Input number data', async () => {
    await input.init({
        title: `How old are you ?`,
        default: 1
    });
    setImmediate(() => input.answer());
    const rs1 = await input.exec();
    expect(rs1).toBe(1);
    setImmediate(() => input.answer(3));
    const rs2 = await input.exec();
    expect(rs2).toBe(3);
});
//# sourceMappingURL=number.spec.js.map