"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const testing_1 = require("../../testing");
const select_1 = require("./select");
let input;
beforeEach(() => {
    input = testing_1.Testing.newElement(select_1.Select);
    testing_1.Testing.reset();
});
afterEach(async () => {
    await input.dispose();
});
test('Input select data', async () => {
    await input.init({
        title: `Pick 1 ?`,
        default: 2,
        choices: [
            { title: 'A1', value: 1 },
            { title: 'A2', value: 2 },
            { title: 'A3', value: 3 },
        ]
    });
    setImmediate(() => input.answer());
    const rs2 = await input.exec();
    expect(rs2).toBe(2);
});
//# sourceMappingURL=select.spec.js.map