import { Scene } from './../components/scene/scene';
import { Logger } from './../libs/logger';
import { TagsManager } from './../managers/tags-manager';
import { TemplatesManager } from './../managers/templates-manager';
import { UtilityFunctionManager } from './../managers/utility-function-manager';
import { RootSceneProps } from './root-scene.props';
export declare class RootScene extends Scene {
    logger: Logger;
    tagsManager: TagsManager;
    templatesManager: TemplatesManager;
    globalUtils: UtilityFunctionManager;
    globalVars: {
        [key: string]: any;
    };
    rootDir: string;
    constructor(logger: Logger);
    exec(): Promise<import("./element-shadow").ElementShadow[] | undefined>;
    dispose(): Promise<void>;
    init(props: RootSceneProps): Promise<void>;
    mergeGlobalVars(obj: any): void;
}
