import { ElementBuilder } from "../element-builder";
import { ElementShadow } from "../element-shadow";
import { SceneProps } from "./scene.props";
export declare class Scene extends ElementShadow {
    private isRoot;
    $$ignoreEvalProps: string[];
    description?: string;
    path?: string;
    encryptedPath?: string;
    content?: string;
    password?: string;
    curDir: string;
    sceneVars: {
        [key: string]: any;
    };
    private group?;
    private elementIDs;
    get elementBuilder(): ElementBuilder;
    getPath(p: string): string;
    constructor(isRoot?: boolean);
    init(props: SceneProps): Promise<void>;
    initGroup(): Promise<void>;
    exec(): Promise<ElementShadow[] | undefined>;
    dispose(): Promise<void | undefined>;
    setElementByID(id: string, elem: ElementShadow): void;
    getElementByID<T extends ElementShadow>(id: string): T;
    getVars(str: any, ctx?: any, others?: any): Promise<any>;
    setVars(varObj: any, vl: any, ctx?: any): Promise<string[] | undefined>;
    mergeVars(obj: any): void;
    private getRemoteFileProps;
    private decryptContent;
    private generateEncryptedFile;
    private loadVars;
    private loadEnv;
}
