"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileStorage = void 0;
const fs_1 = require("fs");
const aes_1 = require("../encrypt/aes");
class FileStorage {
    logger;
    file;
    secure;
    constructor(logger, file, pwd) {
        this.logger = logger;
        this.file = file;
        if (pwd)
            this.secure = new aes_1.AES(pwd);
    }
    load(defaultData) {
        if (!(0, fs_1.existsSync)(this.file)) {
            if (defaultData !== undefined && defaultData !== null) {
                this.save(defaultData);
            }
            return defaultData;
        }
        this.logger.debug(`Loaded\t%s`, this.file);
        const content = (0, fs_1.readFileSync)(this.file).toString();
        return JSON.parse(this.secure?.decrypt(content) || content);
    }
    save(data = {}) {
        this.logger.debug(`Saved\t%s`, this.file);
        const content = JSON.stringify(data);
        (0, fs_1.writeFileSync)(this.file, this.secure?.encrypt(content) || content);
    }
}
exports.FileStorage = FileStorage;
//# sourceMappingURL=file-storage.js.map