"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Vars = void 0;
class Vars {
    sceneVars;
    globalVars;
    constructor(sceneVars, globalVars) {
        this.sceneVars = sceneVars;
        this.globalVars = globalVars;
    }
    get(key) {
        const vars = this.isGlobal(key) ? this.globalVars : this.sceneVars;
        return vars[key];
    }
    set(props) {
        if (!props || Array.isArray(props) || typeof props !== 'object')
            return;
        Object.keys(props)
            .forEach(key => {
            if (this.isGlobal(key[0])) {
                this.globalVars[key] = props[key];
            }
            else {
                this.sceneVars[key] = props[key];
            }
        });
    }
    isGlobal(name) {
        return /[A-Z]/.test(name[0]);
    }
}
exports.Vars = Vars;
//# sourceMappingURL=vars.js.map