"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TagsManager = exports.ClassInFileCharacter = void 0;
const fs_1 = require("fs");
const path_1 = require("path");
const modules_manager_1 = require("./modules-manager");
const packages_manager_1 = require("./packages-manager");
exports.ClassInFileCharacter = "'";
class TagsManager {
    scene;
    modules = {};
    constructor(scene) {
        this.scene = scene;
    }
    async register(modules = {}) {
        if (!modules)
            return;
        Object.keys(modules)
            .forEach(key => {
            this.scene.logger.trace(`Global tag\t[%s] %s`, key, modules[key]);
            this.modules[key] = this.scene.getPath(modules[key]);
        });
    }
    async getTag(name) {
        var _a;
        const path = this.modules[name];
        if (!path)
            throw new Error(`Could not found tag module "${name}"`);
        const Clazz = await (_a = path, Promise.resolve().then(() => __importStar(require(_a))));
        return Clazz;
    }
    reset() {
        this.modules = {};
    }
    async loadElementClass(name, scene) {
        var _a, _b, _c;
        let ElementClazz;
        const [path, className = 'default'] = name.split(exports.ClassInFileCharacter);
        let triedToInstall = false;
        do {
            const errors = [];
            do {
                try {
                    switch (errors.length) {
                        case 0:
                            const OwnerClazz = (await (_a = `../components/${path}`, Promise.resolve().then(() => __importStar(require(_a)))));
                            ElementClazz = OwnerClazz[className];
                            break;
                        case 1:
                            const TagClazz = await this.getTag(path);
                            ElementClazz = TagClazz[className];
                            break;
                        case 2:
                            const fullPath = (0, path_1.join)(modules_manager_1.nodeModulesDir, path);
                            try {
                                const NpmLocalClazz = await (_b = fullPath, Promise.resolve().then(() => __importStar(require(_b))));
                                ElementClazz = NpmLocalClazz[className];
                            }
                            catch (err) {
                                err.$$exit = (0, fs_1.existsSync)(fullPath);
                                throw err;
                            }
                            break;
                        case 3:
                            const NpmGlobalClazz = await (_c = path, Promise.resolve().then(() => __importStar(require(_c))));
                            ElementClazz = NpmGlobalClazz[className];
                            break;
                    }
                    if (ElementClazz && !ElementClazz.prototype) {
                        if (typeof ElementClazz === 'function') {
                            ElementClazz = await ElementClazz();
                        }
                        else {
                            const obj = ElementClazz;
                            ElementClazz = function () { };
                            Object.assign(ElementClazz.prototype, obj);
                        }
                    }
                    if (!ElementClazz || !ElementClazz.prototype)
                        throw new Error(`Could not found the tag "${path}.${className}"`);
                    return ElementClazz;
                }
                catch (err) {
                    errors.push(err);
                    if (err.$$exit) {
                        throw err;
                    }
                }
            } while (errors.length < 4);
            if (triedToInstall) {
                errors.forEach((err) => scene.logger.error(err?.message));
                throw new Error(`Could not found class "${className}" in "${path}"`);
            }
            triedToInstall = true;
            const packageManager = new packages_manager_1.PackagesManager(scene);
            await packageManager.install(path);
        } while (true);
    }
}
exports.TagsManager = TagsManager;
//# sourceMappingURL=tags-manager.js.map