"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const aes_1 = require("./../libs/encrypt/aes");
const base64_1 = require("./../libs/encrypt/base64");
const md5_1 = require("./../libs/encrypt/md5");
const utility_function_manager_1 = require("./utility-function-manager");
const globalUtils = new utility_function_manager_1.UtilityFunctionManager();
test('base64 encrypt/decrypt', async () => {
    const raw = 'thanh';
    const enc = new base64_1.Base64().encrypt(raw);
    expect(globalUtils.base64.encrypt(raw)).toBe(enc);
    expect(globalUtils.base64.decrypt(enc)).toBe(raw);
});
test('md5 encrypt', async () => {
    const raw = 'thanh';
    const enc = new md5_1.MD5().encrypt(raw);
    expect(globalUtils.md5.encrypt(raw)).toBe(enc);
});
test('aes encrypt/decrypt', async () => {
    const raw = 'thanh';
    const salt = 'my salt';
    const enc = new aes_1.AES().encrypt(raw, salt);
    expect(globalUtils.aes.encrypt(raw, salt)).not.toBe(enc);
    expect(globalUtils.aes.decrypt(enc, salt)).toBe(raw);
});
//# sourceMappingURL=utility-function-manager.spec.js.map